import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { EventEmitter, Component, Input, Output, Injectable, NgModule } from '@angular/core';

class AnnotationComponent {
    constructor() {
        this.removable = true;
        this.removeAnnotation = new EventEmitter();
    }
}
AnnotationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: AnnotationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
AnnotationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.4", type: AnnotationComponent, selector: "ngx-annotation", inputs: { annotation: "annotation", removable: "removable" }, outputs: { removeAnnotation: "removeAnnotation" }, ngImport: i0, template: "<span *ngIf=\"annotation\" class=\"annotation-parent\" [style.border-color]=\"annotation.color\"\n    [style.background-color]=\"annotation.color\">\n\n    <span class=\"annotation-content\">\n        <pre>{{ annotation.text }}</pre>\n    </span>\n\n    <!-- Instead of setting the property \"innerText\" of this HTML element, we set \"data-label\". In CSS, we can then\n        reference the content of this property and can use the CSS pseudo- element \"::after\" to insert the content\n        of \"data-label\" as text into the DOM. What's the advantage of this? At first, I tried to use the \"innerText\"\n        property of this HTML element to visualize the annotation's label. Whenever the user selected a range of the\n        original text, then the labels of the annotations were counted into the range, too. This made it difficult to\n        extract which text range the user actually selected. By using the CSS pseudo-class \"::after\", we can prevent\n        the annotations' labels from being included into the selected text range. -->\n\n    <span class=\"annotation-label\" [attr.data-label]=\"annotation.label\" [style.background-color]=\"annotation.color\">\n    </span>\n\n    <span class=\"annotation-button\" *ngIf=\"removable\">\n        <span>\n            <button class=\"remove-annotation\" (click)=\"removeAnnotation.emit(annotation)\">\n            </button>\n        </span>\n    </span>\n\n</span>", styles: ["span.annotation-parent{border:2px solid;border-radius:4px;box-shadow:2px 4px 20px #0000001a;color:#0009;display:block;font-weight:500;line-height:1.3;margin:0 0 .5rem;min-width:26px;padding:0;white-space:normal;word-break:break-word;word-wrap:break-word}span.annotation-content{align-items:center;background-color:#fff;border-top-left-radius:2px;border-top-right-radius:2px;display:flex;flex-wrap:wrap;justify-content:center;padding:0 2px;text-align:center;white-space:normal}span.annotation-content pre{background-color:#0000;color:inherit;font-family:inherit;font-size:inherit;display:block;margin-top:0;margin-bottom:0;overflow:auto;box-sizing:border-box;padding:0}span.annotation-label{color:#fff;align-items:center;justify-content:center;text-align:center;padding:2px 8px 0;display:flex;margin:0;line-height:.8rem;-webkit-touch-callout:none;-webkit-user-select:none;user-select:none}span.annotation-label:after{content:attr(data-label)}span.annotation-button{position:relative;display:block;height:0;width:100%}span.annotation-button span{position:absolute;top:-2.9rem;right:.47rem}button.remove-annotation{position:absolute;height:16px;width:16px;min-width:16px;max-width:16px;min-height:16px;max-height:16px;border:none;border-radius:1000px;-webkit-appearance:none;appearance:none;background-color:#0a0a0a33;display:inline-block;outline:0;flex-shrink:0;flex-grow:0;-webkit-user-select:none;user-select:none;cursor:pointer}button.remove-annotation:hover{background-color:#0a0a0a80}button.remove-annotation:before,button.remove-annotation:after{background-color:#fff;content:\"\";display:block;left:50%;position:absolute;top:50%;transform:translate(-50%) translateY(-50%) rotate(45deg);transform-origin:center center}button.remove-annotation:after{height:50%;width:2px}button.remove-annotation:before{height:2px;width:50%}\n"], directives: [{ type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: AnnotationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-annotation', template: "<span *ngIf=\"annotation\" class=\"annotation-parent\" [style.border-color]=\"annotation.color\"\n    [style.background-color]=\"annotation.color\">\n\n    <span class=\"annotation-content\">\n        <pre>{{ annotation.text }}</pre>\n    </span>\n\n    <!-- Instead of setting the property \"innerText\" of this HTML element, we set \"data-label\". In CSS, we can then\n        reference the content of this property and can use the CSS pseudo- element \"::after\" to insert the content\n        of \"data-label\" as text into the DOM. What's the advantage of this? At first, I tried to use the \"innerText\"\n        property of this HTML element to visualize the annotation's label. Whenever the user selected a range of the\n        original text, then the labels of the annotations were counted into the range, too. This made it difficult to\n        extract which text range the user actually selected. By using the CSS pseudo-class \"::after\", we can prevent\n        the annotations' labels from being included into the selected text range. -->\n\n    <span class=\"annotation-label\" [attr.data-label]=\"annotation.label\" [style.background-color]=\"annotation.color\">\n    </span>\n\n    <span class=\"annotation-button\" *ngIf=\"removable\">\n        <span>\n            <button class=\"remove-annotation\" (click)=\"removeAnnotation.emit(annotation)\">\n            </button>\n        </span>\n    </span>\n\n</span>", styles: ["span.annotation-parent{border:2px solid;border-radius:4px;box-shadow:2px 4px 20px #0000001a;color:#0009;display:block;font-weight:500;line-height:1.3;margin:0 0 .5rem;min-width:26px;padding:0;white-space:normal;word-break:break-word;word-wrap:break-word}span.annotation-content{align-items:center;background-color:#fff;border-top-left-radius:2px;border-top-right-radius:2px;display:flex;flex-wrap:wrap;justify-content:center;padding:0 2px;text-align:center;white-space:normal}span.annotation-content pre{background-color:#0000;color:inherit;font-family:inherit;font-size:inherit;display:block;margin-top:0;margin-bottom:0;overflow:auto;box-sizing:border-box;padding:0}span.annotation-label{color:#fff;align-items:center;justify-content:center;text-align:center;padding:2px 8px 0;display:flex;margin:0;line-height:.8rem;-webkit-touch-callout:none;-webkit-user-select:none;user-select:none}span.annotation-label:after{content:attr(data-label)}span.annotation-button{position:relative;display:block;height:0;width:100%}span.annotation-button span{position:absolute;top:-2.9rem;right:.47rem}button.remove-annotation{position:absolute;height:16px;width:16px;min-width:16px;max-width:16px;min-height:16px;max-height:16px;border:none;border-radius:1000px;-webkit-appearance:none;appearance:none;background-color:#0a0a0a33;display:inline-block;outline:0;flex-shrink:0;flex-grow:0;-webkit-user-select:none;user-select:none;cursor:pointer}button.remove-annotation:hover{background-color:#0a0a0a80}button.remove-annotation:before,button.remove-annotation:after{background-color:#fff;content:\"\";display:block;left:50%;position:absolute;top:50%;transform:translate(-50%) translateY(-50%) rotate(45deg);transform-origin:center center}button.remove-annotation:after{height:50%;width:2px}button.remove-annotation:before{height:2px;width:50%}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { annotation: [{
                type: Input
            }], removable: [{
                type: Input
            }], removeAnnotation: [{
                type: Output
            }] } });

class Annotation {
    /**
     * Represents an annotated part of the referenced text.
     *
     * @param startIndex The zero-based index number indicating the beginning of this annotation.
     * @param endIndex The zero-based index number indicating the end of the annotation. The annotation
     * includes the characters up to, but not including, the character indicated by the end.
     * @param label Arbitrary string displayed as label below the annotation, e. g. `City`.
     * @param color The color of the box which is displayed around the annotation, e. g. 'red' or 'rgb(220, 53, 69)'.
     */
    constructor(startIndex, endIndex, label, color) {
        this.startIndex = startIndex;
        this.endIndex = endIndex;
        this.label = label;
        this.color = color;
    }
}

class TokenizerService {
    constructor() { }
    splitTextIntoTokens(text, annotations) {
        if (annotations.length === 0) {
            return [text];
        }
        const annotationStartingIndices = new Map();
        const tokens = [];
        // Creates a map which contains the starting indices for each annotation
        // as keys. This way, we know the positions / indices in the text where
        // we need to display an annotation instead of the plaintext.
        annotations.forEach((a) => {
            annotationStartingIndices.set(a.startIndex, a);
            a.text = text.substring(a.startIndex, a.endIndex);
        });
        let currentIndex = 0;
        let isAnnotationActive = false;
        let annotationActiveUntilIndex = 0;
        let buffer = '';
        text.split('').forEach((char) => {
            if (annotationActiveUntilIndex === currentIndex) {
                isAnnotationActive = false;
            }
            if (!annotationStartingIndices.has(currentIndex) && !isAnnotationActive) {
                buffer += char;
            }
            else if (annotationStartingIndices.has(currentIndex)) {
                if (buffer.length > 0) {
                    tokens.push(buffer);
                }
                tokens.push(annotationStartingIndices.get(currentIndex));
                annotationActiveUntilIndex = annotationStartingIndices.get(currentIndex).endIndex;
                buffer = '';
                isAnnotationActive = true;
            }
            currentIndex++;
        });
        if (buffer.length > 0) {
            tokens.push(buffer);
        }
        return tokens;
    }
}
TokenizerService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: TokenizerService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
TokenizerService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: TokenizerService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: TokenizerService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class NgxAnnotateTextComponent {
    constructor(elementRef, tokenService) {
        this.elementRef = elementRef;
        this.tokenService = tokenService;
        /** Represents the parts of the given text which shall be annotated. */
        this.annotations = [];
        /**
         * Determines whether annotations shall have a small button in the top right corner so that the user can
         * remove an annotation.
         */
        this.removable = true;
        /** The text which shall be displayed and annotated. */
        this.text = '';
        /** Emits the list of existing annotations after an element has been removed. */
        this.annotationsChange = new EventEmitter();
        /** @internal */
        this.tokens = [];
    }
    ngOnInit() {
        this.tokens = this.tokenService.splitTextIntoTokens(this.text, this.annotations);
    }
    ngOnChanges(changes) {
        if ('annotations' in changes || 'text' in changes) {
            this.tokens = this.tokenService.splitTextIntoTokens(this.text, this.annotations);
        }
    }
    /**
     * Provides start and end index of the currently selected text.
     *
     * @returns Returns the start index and end index of the currently selected text range. Returns `undefined`
     * if no text is currently selected.
     */
    getCurrentTextSelection() {
        this.updateTextSelection();
        if (this.selectionStart === undefined || this.selectionEnd === undefined || this.selectionStart >= this.selectionEnd) {
            return undefined;
        }
        return {
            startIndex: this.selectionStart,
            endIndex: this.selectionEnd,
        };
    }
    /**
     * Checks whether the given text selection is overlapping with existing annotations.
     *
     * @param selection The current text selection.
     * @returns Returns `true` if the given text selection is (partially) overlapping with
     * an existing annotation. Returns `false` otherwise.
     */
    isOverlappingWithExistingAnnotations(selection) {
        const overlappingAnnotation = this.annotations.find((annotation) => {
            return Math.max(annotation.startIndex, selection.startIndex) < Math.min(annotation.endIndex, selection.endIndex);
        });
        return overlappingAnnotation != undefined;
    }
    /** @internal */
    isAnnotation(annotation) {
        return annotation instanceof Annotation;
    }
    /** @internal */
    onRemoveAnnotation(annotation) {
        this.annotations = this.annotations.filter(a => a !== annotation);
        this.annotationsChange.emit(this.annotations);
        this.tokens = this.tokenService.splitTextIntoTokens(this.text, this.annotations);
    }
    updateTextSelection() {
        const selection = window.getSelection();
        if (selection != null && selection.rangeCount > 0) {
            const range = selection.getRangeAt(0);
            const preSelectionRange = range.cloneRange();
            preSelectionRange.selectNodeContents(this.elementRef.nativeElement);
            preSelectionRange.setEnd(range.startContainer, range.startOffset);
            this.selectionStart = [...preSelectionRange.toString()].length;
            this.selectionEnd = this.selectionStart + [...range.toString()].length;
        }
        else {
            this.selectionStart = undefined;
            this.selectionEnd = undefined;
        }
    }
}
NgxAnnotateTextComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgxAnnotateTextComponent, deps: [{ token: i0.ElementRef }, { token: TokenizerService }], target: i0.ɵɵFactoryTarget.Component });
NgxAnnotateTextComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.4", type: NgxAnnotateTextComponent, selector: "ngx-annotate-text", inputs: { annotations: "annotations", annotationClass: "annotationClass", removable: "removable", text: "text" }, outputs: { annotationsChange: "annotationsChange" }, usesOnChanges: true, ngImport: i0, template: "<span *ngFor=\"let token of tokens\">\n\n  <ngx-annotation *ngIf=\"isAnnotation(token)\" [annotation]=\"token\" [removable]=\"removable\"\n    (removeAnnotation)=\"onRemoveAnnotation($event)\" [class]=\"(annotationClass || '')\">\n  </ngx-annotation>\n\n  <span *ngIf=\"!isAnnotation(token)\" class=\"unlabeled\">{{ token }}</span>\n\n</span>", styles: [":host{align-items:flex-start;display:flex;flex-wrap:wrap;white-space:pre-wrap}span.unlabeled{line-height:1.5rem}\n"], components: [{ type: AnnotationComponent, selector: "ngx-annotation", inputs: ["annotation", "removable"], outputs: ["removeAnnotation"] }], directives: [{ type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgxAnnotateTextComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-annotate-text', template: "<span *ngFor=\"let token of tokens\">\n\n  <ngx-annotation *ngIf=\"isAnnotation(token)\" [annotation]=\"token\" [removable]=\"removable\"\n    (removeAnnotation)=\"onRemoveAnnotation($event)\" [class]=\"(annotationClass || '')\">\n  </ngx-annotation>\n\n  <span *ngIf=\"!isAnnotation(token)\" class=\"unlabeled\">{{ token }}</span>\n\n</span>", styles: [":host{align-items:flex-start;display:flex;flex-wrap:wrap;white-space:pre-wrap}span.unlabeled{line-height:1.5rem}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: TokenizerService }]; }, propDecorators: { annotations: [{
                type: Input
            }], annotationClass: [{
                type: Input
            }], removable: [{
                type: Input
            }], text: [{
                type: Input
            }], annotationsChange: [{
                type: Output
            }] } });

class NgxAnnotateTextModule {
}
NgxAnnotateTextModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgxAnnotateTextModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxAnnotateTextModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgxAnnotateTextModule, declarations: [AnnotationComponent,
        NgxAnnotateTextComponent], imports: [CommonModule], exports: [NgxAnnotateTextComponent] });
NgxAnnotateTextModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgxAnnotateTextModule, imports: [[
            CommonModule,
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgxAnnotateTextModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        AnnotationComponent,
                        NgxAnnotateTextComponent,
                    ],
                    imports: [
                        CommonModule,
                    ],
                    exports: [
                        NgxAnnotateTextComponent,
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-annotate-text
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Annotation, NgxAnnotateTextComponent, NgxAnnotateTextModule };
//# sourceMappingURL=ngx-annotate-text.mjs.map
